<?php
defined ( '_JEXEC' ) or die ( 'Restricted access' );
/**
 * @package		jomLike
 * @author 		'corePHP' LLC.
 * @copyright 	(C) 2010- 'corePHP' LLC.
 * @license 	GNU/GPL v2 http://www.gnu.org/licenses/gpl-2.0.html
 *
 * Support: http://support.corephp.com/
 */

jimport ( 'joomla.application.component.model' );

class JomLikeModelJomLike extends JModel {
	protected $_id = null;
	protected $_data = null;

	function __construct() {
		parent::__construct ();

		$array = JRequest::getVar ( 'cid', 0, '', 'array' );
		$this->setId ( ( int ) $array [0] );
	}

	function setId($id) {
		$this->_id = $id;
		$this->_data = null;
	}

	function &getData() {
		// Load the data
		if (empty ( $this->_data )) {
			$query = $this->_buildQuery ();
			$this->_data = $this->_getList ( $query );
		}

		if (! $this->_data) {
			$this->_data = new stdClass ();
			$this->_data->id = 0;
		}
		return $this->_data;
	}

	function _buildQuery() {
		$query = ' SELECT * FROM #__jomlike ';
		return $query;
	}

	function store() {
		$id = JRequest::getInt ( 'published', 0 );

		// This looks dumb, but joomla wouldn't allow me to chain them.
		$sql = "UPDATE `#__jomlike` set published=0";
		$this->_db->setQuery ( $sql );
		$this->_db->query ();
		$sql = "UPDATE `#__jomlike` set published=1 where id='{$id}'";
		$this->_db->setQuery ( $sql );
		$this->_db->query ();

		return true;
	}

	function delete() {
		$id = JRequest::getInt ( 'published', 0 );
		$row = & $this->getTable ();

		if (! $row->delete ( $id )) {
			$this->setError ( $row->getErrorMsg () );
			return false;
		}

		return true;
	}

}
