<?php
defined ( '_JEXEC' ) or die ( 'Restricted access' );
/**
 * @package		jomLike
 * @author 		'corePHP' LLC.
 * @copyright 	(C) 2010- 'corePHP' LLC.
 * @license 	GNU/GPL v2 http://www.gnu.org/licenses/gpl-2.0.html
 *
 * Support: http://support.corephp.com/
 */

jimport ( 'joomla.application.component.model' );

class jomlikeModeljomlike_likes extends JModel {

	public function getData($data) {

		$userId = JFactory::getUser ()->get ( 'id' );

		$sql = "SELECT * FROM #__jomlike_likes WHERE id='{$data['id']}' && element='{$data['element']}' LIMIT 1";
		$this->_db->setQuery ( $sql );

		$data ['task'] = '';

		if (NULL !== $res = $this->_db->loadAssoc ()) {
			//we like or dislike this
			$likeArray = array_filter ( explode ( ',', $res ['like'] ) );
			$data ['count'] ['like'] = count ( $likeArray );
			$dislikeArray = array_filter ( explode ( ',', $res ['dislike'] ) );
			$data ['count'] ['dislike'] = count ( $dislikeArray );

			if (in_array ( $userId, $likeArray )) {
				$data ['task'] = 'like';
			} else if (in_array ( $userId, $dislikeArray )) {
				$data ['task'] = 'dislike';
			}
		}

		return $data;
	}

	public function store() {

		$data = json_decode ( JRequest::getVar ( 'data' ), true );

		if (! is_array ( $data )) {
			return;
		}

		$data = array ('id' => $data ['id'], 'element' => $data ['element'] );

		$userId = JFactory::getUser ()->get ( 'id' );

		$sql = "SELECT * FROM #__jomlike_likes WHERE id='{$data['id']}' && element='{$data['element']}' LIMIT 1";
		$this->_db->setQuery ( $sql );
		if (NULL !== $res = $this->_db->loadAssoc ()) {
			$res ['like'] = explode ( ',', $res ['like'] );
			$res ['dislike'] = explode ( ',', $res ['dislike'] );
			$data = array_merge ( $data, $res );
		} else {
			$data ['like'] = array ();
			$data ['dislike'] = array ();
		}

		switch (JRequest::getCmd ( 'task' )) {
			case 'like' :
				if (FALSE !== $key = array_search ( $userId, $data ['dislike'] )) {
					unset ( $data ['dislike'] [$key] );
				}
				$data ['like'] [] = $userId;
				break;
			case 'dislike' :
				if (FALSE !== $key = array_search ( $userId, $data ['like'] )) {
					unset ( $data ['like'] [$key] );
				}
				$data ['dislike'] [] = $userId;
				break;
			case 'unlike' :
				if (FALSE !== $key = array_search ( $userId, $data ['like'] )) {
					unset ( $data ['like'] [$key] );
				}
				break;
			case 'undislike' :
				if (FALSE !== $key = array_search ( $userId, $data ['dislike'] )) {
					unset ( $data ['dislike'] [$key] );
				}
				break;
		}

		$data ['like'] = implode ( ",", array_unique ( $data ['like'] ) );
		$data ['dislike'] = implode ( ',', array_unique ( $data ['dislike'] ) );

		foreach ( $data as $k => $v ) {
			$set [] = $this->_db->nameQuote ( $k ) . '=' . $this->_db->Quote ( $v );
		}

		$sql = 'REPLACE INTO #__' . $this->_name . ' SET ' . implode ( ',', $set );
		$this->_db->setQuery ( $sql );
		$this->_db->query ();

		return true;
	}
}