<?php
defined ( '_JEXEC' ) or die ( 'Restricted access' );
/**
 * @package		jomLike
 * @author 		'corePHP' LLC.
 * @copyright 	(C) 2010- 'corePHP' LLC.
 * @license 	GNU/GPL v2 http://www.gnu.org/licenses/gpl-2.0.html
 *
 * Support: http://support.corephp.com/
 */

jimport ( 'joomla.application.component.view' );

class jomlikeViewjomlike extends JView {

	public function display($tpl = null) {
		JFactory::getLanguage ()->load ( 'com_jomlike' );

		$user = JFactory::getUser ();

		if (1 == $user->guest) {
			$this->assignRef ( 'guestMsg', JText::_ ( 'JOMLIKE_MUSTLOGIN' ) );
		}

		$modelLikes = $this->getModel ( 'jomlike_likes' );
		$data = json_decode ( JRequest::getVar ( 'data' ), true );

		if ('store' === JRequest::getVar ( 'method' ) && 1 != $user->guest) {
			$modelLikes->store ();
			$this->_updateJomsocial ($data);
		}

		$this->assignRef ( 'data', $modelLikes->getData ( $data ) );

		parent::display ( $tpl );
	}

	private function _updateJomsocial($data) {
		if (is_readable ( JPATH_SITE . DS . 'components' . DS . 'com_community' . DS . 'libraries' . DS . 'core.php' )) {
			require_once JPATH_SITE . DS . 'components' . DS . 'com_community' . DS . 'libraries' . DS . 'core.php';

			$act = new stdClass ();
			$act->cmd = 'wall.write';
			$act->actor = JFactory::getUser ()->id;
			$act->target = 0; // no target
			$act->title = JText::_ ( "{actor} ".JRequest::getCMD('task')."s <a href=\"".base64_decode($data['jomLikeUrl'])."\">{$data['title']}</a>." );
			$act->content = '';
			$act->app = 'wall';
			$act->cid = 0;
			CFactory::load ( 'libraries', 'activities' );
			CActivityStream::add ( $act );
		}
	}
}