<?php
defined ( '_JEXEC' ) or die ( 'Restricted access' );
/**
 * @package		jomLike
 * @author 		'corePHP' LLC.
 * @copyright 	(C) 2010- 'corePHP' LLC.
 * @license 	GNU/GPL v2 http://www.gnu.org/licenses/gpl-2.0.html
 *
 * Support: http://support.corephp.com/
 */

jimport ( 'joomla.application.component.controller' );

class jomLikeController extends JController {

	function display() {
		require_once JPATH_COMPONENT.'/helpers/jomlike.php';
		parent::display ();
		JomLikeHelper::addFooter();
	}

	function save() {
		$model = $this->getModel ( 'jomlike' );

		if ($model->store ()) {
			$msg = JText::_ ( 'SAVED' );
		} else {
			$msg = JText::_ ( 'ERROR_SAVING' );
		}

		// Check the table in so it can be edited.... we are done with it anyway
		$link = 'index.php?option=com_jomlike';
		$this->setRedirect ( $link, $msg );
	}

	function remove() {
		$model = $this->getModel ( 'jomlike' );
		if (! $model->delete ()) {
			$msg = JText::_ ( 'EOOMGCNBD' );
		} else {
			$msg = JText::_ ( 'GREET_DELETED' );
		}

		$this->setRedirect ( 'index.php?option=com_jomlike', $msg );
	}

	function add() {
		$file = array_pop ( JRequest::get ( 'FILES' ) );
		$ext = array_pop ( explode ( '.', $file ['name'] ) );

		$imgPath = JPATH_COMPONENT_SITE . DS . 'assets' . DS . 'images' . DS;
		$destination = $imgPath . $file ['name'];

		if (! move_uploaded_file ( $file ['tmp_name'], $destination )) {
			$msg = JText::_ ( 'ECMUF' );
			$this->setRedirect ( 'index.php?option=com_jomlike', $msg );
		}

		$model = $this->getModel ( 'jomlike' );
		$model->_db->setQuery ( "INSERT INTO `#__jomlike` set `published`=0,`ext`='{$ext}';" );
		$model->_db->query ();
		$id = $model->_db->insertid ();

		if (! rename ( $destination, $imgPath . "id{$id}-like-button-bg.{$ext}" )) {
			$msg = JText::_ ( 'ECRUF' );
			$this->setRedirect ( 'index.php?option=com_jomlike', $msg );
		}

		$this->setRedirect ( 'index.php?option=com_jomlike', JText::_ ( 'WHUYF' ) );
	}

	function cancel() {
		$msg = JText::_ ( 'OCANCE' );
		$this->setRedirect ( 'index.php?option=com_jomlike', $msg );
	}

}