<?php
defined ( '_JEXEC' ) or die ( 'Restricted access' );
/**
 * @package		jomLike
 * @author 		'corePHP' LLC.
 * @copyright 	(C) 2010- 'corePHP' LLC.
 * @license 	GNU/GPL v2 http://www.gnu.org/licenses/gpl-2.0.html
 *
 * Support: http://support.corephp.com/
 */

jimport ( 'joomla.plugin.plugin' );

class plgSystemJomLike extends JPlugin {

	public function onAfterDispatch() {
		$app = JFactory::getApplication ( 'site' );
		if (! $app->isSite () || ! defined ( 'JOMLIKE_RAN' )) {
			return;
		}

		$option = JRequest::getCmd ( 'option' );
		$doc = JFactory::getDocument ();

		$db = JFactory::getDBO ();
		$sql = "SELECT * FROM #__jomlike WHERE published=1";
		$db->setQuery ( $sql );
		$item = $db->loadObject ();

		$style = '
			#like-container .like-button,
			#like-container .unlike-button,
			#like-container .dislike-button,
			#like-container .peepDislike,
			#like-container .peepLike,
			#like-container .meLike,
			#like-container .meDislike{
				background: url("' . JRoute::_ ( JURI::base () . 'components/com_jomlike/assets/' ) . 'images/id' . $item->id . '-like-button-bg.' . $item->ext . '") repeat-x scroll 0 0 #FFFFFF !important;
			}';
		$doc->addStyleDeclaration ( $style );

		$styleSheet = JRoute::_ ( JURI::base () . 'components/com_jomlike/assets/css/like.css' );
		$doc->addStyleSheet ( $styleSheet, 'text/css', "screen" );

		$doc->addScript ( 'http://ajax.googleapis.com/ajax/libs/jquery/1.5.1/jquery.min.js' );
		$doc->addScript ( JURI::base () . 'components/com_jomlike/assets/scripts/jomlike.js' );
		$doc->addScriptDeclaration ( 'var live_site=\'' . JURI::base () . 'index.php\'; var jomLikeVal = new Array();' );
	}
}