<?php
defined ( '_JEXEC' ) or die ( 'Restricted access' );
/**
 * @package		jomLike
 * @author 		'corePHP' LLC.
 * @copyright 	(C) 2010- 'corePHP' LLC.
 * @license 	GNU/GPL v2 http://www.gnu.org/licenses/gpl-2.0.html
 *
 * Support: http://support.corephp.com/
 */

// Import library dependencies
jimport ( 'joomla.plugin.plugin' );

class plgContentJomLike_Articles extends JPlugin {

	public function onBeforeDisplayContent(&$article, &$params, $limitstart) {

		$app = JFactory::getApplication ();
		if ($app->scope != 'com_content') {
			return;
		}

		! defined ( 'JOMLIKE_RAN' ) ? define ( 'JOMLIKE_RAN', 1 ) : '';

		JRequest::setVar ( 'data', json_encode ( array ('id' => $article->id, 'element' => 'article', 'title'=>$article->title, 'jomLikeUrl' => base64_encode(JRoute::_("index.php?option=com_content&view=article&id={$article->id}") ) ) ) );

		$this->loadLanguage ( 'com_jomlike' );

		$componentPath = JPATH_SITE . DS . 'components' . DS . 'com_jomlike';
		require_once $componentPath . DS . 'models' . DS . 'jomlike_likes.php';
		require_once $componentPath . DS . 'controller.php';
		$component = new jomLikeController ( array ('name' => 'jomlike' ) );
		$component->addViewPath ( $componentPath . DS . 'views' );
		$component->addModelPath ( $componentPath . DS . 'models' );
		$view = $component->getView ( 'jomlike', 'raw' );
		$view->setModel ( $component->getModel ( 'jomlike_likes' ) );
		$view->addTemplatePath ( $componentPath . DS . 'views' . DS . 'jomlike' . DS . 'tmpl' );
		ob_start ();
		$view->display ();
		$article->text .= ob_get_contents ();
		ob_end_clean ();
	}
}