<?php
defined ( '_JEXEC' ) or die ( 'Restricted access' );
/**
 * @package		jomLike
 * @author 		'corePHP' LLC.
 * @copyright 	(C) 2010- 'corePHP' LLC.
 * @license 	GNU/GPL v2 http://www.gnu.org/licenses/gpl-2.0.html
 *
 * Support: http://support.corephp.com/
 */
require_once (JPATH_ROOT . DS . 'components' . DS . 'com_community' . DS . 'libraries' . DS . 'core.php');

class plgCommunityJomlike_jomsocial extends CApplications {

	var $name = 'jomLike Plug-in';
	var $_name = 'jomlike';

	public function onAjaxCall($func, array $args, JAXResponse $resp) {
		if (0 === preg_match ( '/^system,ajax.*?[lL]ike$/', $func )) {
			return TRUE;
		}

		$element = $args [0];
		$id = $args [1];

		$db = JFactory::getDBO ();

		$columnName = 'title';
		$dbTable = '#__community_' . ('s' === substr ( $element, - 1, 1 ) ? $element : $element . 's');
		$route = JRoute::_ ( "index.php?option=com_community&Itemid={$id}&view={$element}" );

		switch ($element) {
			case 'profile' :
				$columnName = 'name';
				$dbTable = '#__users';
				$route = JRoute::_ ( "index.php?option=com_community&userid={$id}&view={$element}" );
				break;
			case 'videos':
				$route = JRoute::_("index.php?option=com_community&view=videos&task=video&videoid={$id}");
				break;
			case 'photo':
				$db->setQuery ( "SELECT albumid FROM #__community_photos WHERE id={$id}" );
				$albumId = $db->loadResult();
				$columnName = 'caption';
				$route = JRoute::_("index.php?option=com_community&view=photos&task=photo&albumid={$albumId}#photoid={$id}");
				break;
			case 'groups':
				$columnName = 'name';
				$route = JRoute::_("index.php?option=com_community&view=groups&task=viewgroup&groupid={$id}");
				break;
			case 'events':
				$route = JRoute::_("index.php?option=com_community&view=events&task=viewevent&eventid={$id}");
				break;
		}

		$sql = "SELECT `{$columnName}` FROM `{$dbTable}` WHERE id={$id}";
		$db->setQuery ( $sql );
		$title = $db->loadResult () ? $db->loadResult () : 'this';

		$act = new stdClass ();
		$act->cmd = 'wall.write';
		$act->actor = JFactory::getUser ()->id;
		$act->target = 0; // no target
		$act->title = JText::_ ( "{actor} " . ucfirst ( array_pop ( explode ( 'ajax', $func ) ) ) . "s <a href=\"" . $route . "\">{$title}</a>." );
		$act->content = '';
		$act->app = 'wall';
		$act->cid = 0;
		CFactory::load ( 'libraries', 'activities' );
		CActivityStream::add ( $act );

		return TRUE;
	}
}