<?php
defined ( '_JEXEC' ) or die ( 'Restricted access' );
/**
 * @package		jomLike
 * @author 		'corePHP' LLC.
 * @copyright 	(C) 2010- 'corePHP' LLC.
 * @license 	GNU/GPL v2 http://www.gnu.org/licenses/gpl-2.0.html
 *
 * Support: http://support.corephp.com/
 */

JLoader::register ( 'K2Plugin', JPATH_ADMINISTRATOR . DS . 'components' . DS . 'com_k2' . DS . 'lib' . DS . 'k2plugin.php' );

class plgK2Jomlike_K2 extends K2Plugin {

	var $pluginName = 'jomLike';
	var $pluginNameHumanReadable = 'jomLike Buttons';

	function onK2AfterDisplayContent(& $item, & $params, $limitstart) {
		$app = JFactory::getApplication ( 'site' );
		! defined ( 'JOMLIKE_RAN' ) ? define ( 'JOMLIKE_RAN', 1 ) : '';

		JRequest::setVar ( 'data', json_encode ( array ('id' => $item->id, 'element' => 'k2item', 'title'=>$item->title, 'jomLikeUrl'=> base64_encode($item->link) ) ) );

		$componentPath = JPATH_SITE . DS . 'components' . DS . 'com_jomlike';
		require_once $componentPath . DS . 'models' . DS . 'jomlike_likes.php';
		require_once $componentPath . DS . 'controller.php';
		$component = new jomLikeController ( array ('name' => 'jomlike' ) );
		$component->addViewPath ( $componentPath . DS . 'views' );
		$component->addModelPath ( $componentPath . DS . 'models' );
		$view = $component->getView ( 'jomlike', 'raw' );
		$view->setModel ( $component->getModel ( 'jomlike_likes' ) );
		$view->addTemplatePath ( $componentPath . DS . 'views' . DS . 'jomlike' . DS . 'tmpl' );
		ob_start ();
		$view->display ();
		$text .= ob_get_contents ();
		ob_end_clean ();

		return $text;
	}
}